<?php
/*
 TinyMCE PHP Facade Class

======================
	How to Use
======================
1. Set the values in 'jscripts/tiny_mce/plugins/images/connector/php/config.php' 

2. Create a new instance of the class
$tinymce = new TinyMCE;

3. Paste the following in your html document between the <head> tags 
<?php echo $tinymce->run() ?>

======================
	TinyMCE Config
======================
You can set custom configurations for the class by passing values to the config array. 

EX: 
$config['width'] = '800px';
$config['height'] = '300px';

$tinymce->set_config($config); 

For a full list of configuration options please look at the site. 
http://wiki.moxiecode.com/index.php/TinyMCE:Configuration

======================
	The Path Config
======================
$config['path'] = 'your path';

The path should automatically set itself, if not, you can also do it manually. 

======================
	PHP Config
======================
This class also makes it easy to create pre-built button configurations. 
There are already two, advanced (the default) and basic. 

----------------------
To create your own buttons
----------------------
$tinymce->set_buttons('mybuttons', 
array(
	'link, unlink,|, images, | , code, cleanup',
	'formatselect, removeformat, |, bold, italic, underline'
);
note: each element in the array is a new line in the editor (so the above example creates two lines)
 */
Class TinyMCE
{
	//-----------------------
	//custom buttons
	//-----------------------
	var $buttons = array(
		
		'advanced' => 
		array(
			'link, unlink,|, images , | ,code, cleanup, |,  fullscreen, preview, ',
			'formatselect, removeformat, |, bold,italic,underline, |, justifyleft, justifyright, justifyfull, |, numlist, bullist, outdent, indent ,|, charmap',
			''
		),
		'basic' =>
		array(
			'bold,italic,underline, |, link, unlink,|,code',
			'',
			'' 
		)
	
	);
	//-----------------------
	// Config
	//-----------------------
	var $config = array(
		'path' 					  => '', //will automatically be set
	
		'mode'					  => 'specific_textareas',	
		'editor_selector'         => 'tinymce',				
		'elements'				  => '',
		'theme' 			      => 'advanced',
		'plugins' 				  => 'images, safari,  fullscreen, preview, safari, inlinepopups, contextmenu',
		'width'					  => '100%',
		'height'				  => '500px',
		'relative_urls' 		  => false,
	
		'theme_advanced_toolbar_location'   => "top",
		'theme_advanced_toolbar_align'      => "left",
		'theme_advanced_statusbar_location' => "bottom",
		'theme_advanced_resizing'		    => true,
		'theme_advanced_resize_horizontal'  => false,		
	
		'content_css' => '',
		
		//php specific config values
		'buttons' 				  => 'advanced', //advanced or basic
	);

	//-----------------------
	// Functions
	//-----------------------
	var $functions = array(
		'hide'					  => false
	);
	function __construct()
	{
		
		
		
		
	}

	function set_config($config)
	{
		if(is_array($config) && !empty($config))
		{
			foreach($config as $key => $value)
			{
				$this->config[$key] = $value; 
			}
		}
	}

	function set_buttons($name, $array)
	{
		$this->buttons[$name] = array(); 
	}
	
	function run()
	{
		if(!$this->config['path'])
		{
			$real_path = str_replace("\\", "/", realpath(dirname(__FILE__)));
			$url = str_replace($_SERVER['DOCUMENT_ROOT'], '/', $real_path);
			$url = str_replace('//', '/', $url); 
			//$real_path = str_replace(":", "", substr($real_path, strpos($real_path,":")));
			$this->config['path'] = $url; 
		}
		
		$out .= '<script type = "text/javascript" src = "'.$this->config['path'].'/jscripts/tiny_mce/tiny_mce.js"></script>'."\n"; 
		$out .= '<script type = "text/javascript" src = "'.$this->config['path'].'/jscripts/tiny_mce/plugins/tinybrowser/tb_tinymce.js.php" ></script>'."\n"; 
		$out .= '<script type = "text/javascript">'."\n"; 
		
		
		
		//tiny mce 
		$out .= '
		tinyMCE.init({
		'; 
		
		$out .= 'setup : function(ed) 
		{
			ed.onChange.add(function(ed) 
			{
				tinyMCE.triggerSave();
			});
		},
		';
		
		//the buttons
		$btns = $this->buttons[$this->config['buttons']];
		$numRows = count($btns);
		for($i=0; $i<$numRows; $i++)
		{
			$this->config['theme_advanced_buttons'.($i+1)] = $btns[$i]; 
		}
		unset($this->config['buttons']);
		
		
		//the php parameters
		if(is_array($this->config))
		{
			$i = 0; 
			
			foreach($this->config as $key => $value)
			{
				if($key!='path')
				{
					$d = ($i!=count($this->config)-1) ? ',' : ''; 
					$out .= $key.':"'.$value.'"'.$d."\n";  
					
				}
				$i++; 
			}
		}
	
		
		$out .= '});'; 
		
		
		$out .= "\n</script>\n";
		
		return $out; 
	}
	
}
?>